; Program za 32-bitno dijeljenje metodom oduzimanja, v. 1
; - Uvjet programa: djeljenik i djelitelj su bez predznaka

	AREA div_32_v1, CODE, READWRITE
	
ADDR EQU 0x8100			; adresa na kojoj se nalaze podatci
	
	ENTRY
	
	MOV R4, #ADDR   	; postavlja u registar R4 adresu podataka
	LDR R5, [R4], #4	; djeljenik se ucitava u R5
	LDR R6, [R4], #4	; djelitelj se ucitava u R6
	MOV R7, #0		; cisti se reg. za spremanje rezultata (R7)
DIV
	CMP R6, R5			; ako je djelitelj > trenutacnog
								; ostatka (R5)
	BHI KRAJ				; zapisi rezultate i zavrsi dijeljenje
	SUB R5, R5, R6		; inace oduzmi djelitelj od trenutacnog
								; ostatka
	ADD R7, R7, #1		; i povecaj rezultat za 1
	B DIV					; ponavljaj petlju
	
KRAJ
	STR R5, [R4], #4	; u memoriju se najprije zapisuje ostatak
	STR R7, [R4]		; a zatim rezultat

	MOV R0, #0x18		; angel_SWIreason_ReportException
	LDR R1, =0x20026	; ADP_Stopped_ApplicationExit
	SWI 0x123456    	; ARM semihosting SWI
	END 

