; Primjer poziva potprograma koji ima parametre na stogu
; potprogram racuna X=(X<<A) + B

	AREA func_param_v1, CODE, READONLY
	
	ENTRY
	
	MOV R13, #0x8100				; definicija vrha stoga
	MOV R0, #1						; X=1
	MOV R1, #4						; parametar A
	MOV R2, #3						; parametar B
	STMFD R13!, {R0,R1,R2}	; parametri se spremaju na stog
	BL FUNC_PARAM					;poziv potprograma za povecavanje
	LDMFD R13!, {R0}			; rezultat se sa stoga ucitava u R0
kraj
	MOV R0, #0x18			; angel_SWIreason_ReportException
	LDR R1, =0x20026 	; ADP_Stopped_ApplicationExit
	SWI 0x123456      	; ARM semihosting SWI


FUNC_PARAM								; potprogram
	LDMFD R13!, {R4,R5,R6}	; ucitavanje ulaznih parametara
	ADD R4, R6, R4, LSL R5	; racunanje funkcije
	STMFD R13!, {R4}				; spremanje rezultata
	MOV PC,LR							; povratak iz potprograma
		
	END

