; Primjer poziva potprograma koji ima parametre navedene iza naredbe za poziv.
; Potprogram racuna R0=(R0<<A) + B

	AREA func_param_v2, CODE, READONLY
	
	ENTRY
	
	MOV R0, #1
	BL FUNC_PARAM			; poziv potprograma za povecavanje
	DCD 4						; parametar A
	DCD 3						; parametar B

kraj
	MOV R0, #0x18			; angel_SWIreason_ReportException
	LDR R1, =0x20026 	; ADP_Stopped_ApplicationExit
	SWI 0x123456      	; ARM semihosting SWI


FUNC_PARAM						; potprogram

	LDR R1, [R14], #4	; prvi parametar (A) se ucitava u R1
	LDR R2, [R14], #4	; drugi parametar (B) se ucitava u R2
									; povratna adresa je u r14
	ADD R0, R2, R0, LSL R1	; racunanje funkcije

	MOV PC,LR					; povratak iz potprograma
	END

