; Program za racunanje zbroja niza elemenata, verzija 1
; Parametri: 	0x8100 - tu se nalazi adresa pocetka bloka
;		0x8104 - tu se nalazi duljina bloka
;		0x8108 - tu se nalazi adresa rezultata

	AREA memsum_v1, CODE, READWRITE

ADDR EQU 0x8100			; adresa parametara

	ENTRY

	MOV R8, #ADDR   	
	LDR R4, [R8], #4	; R4 = adresa pocetka bloka
	LDR R5, [R8], #4	; R5 = duljina bloka
	LDR R6, [R8]		; R6 = adresa rezultata
	
	CMP R5, #0		; ako duljina = 0 zavrsi
	BEQ KRAJ

	MOV R0, #0		; sumaL
	MOV R1, #0		; sumaH
	
PETLJA
	LDR R8, [R4], #4	; ucitavanje broja iz bloka
	ADDS R0, R0, R8		; 64--bitno zbrajanje
	ADC  R1, R1, #0
	SUBS R5, R5, #1		; smanjuje se brojac prolazaka kroz petlju
	BNE PETLJA		

	STR R0, [R6], #4	; spremanje rezultata L
	STR R1, [R6]		; spremanje rezultata H

KRAJ

	MOV R0, #0x18		; angel_SWIreason_ReportException
	LDR R1, =0x20026 	; ADP_Stopped_ApplicationExit
	SWI 0x123456      	; ARM semihosting SWI
		
	END 


