; Puni blok memorije zadanim brojem
; Uvjeti zadatka:
; - na adresi 0x8100 je broj kojim se puni memorija
; - na sljedecoj adresi je memorijska adresa pocetka bloka
; - na sljedecoj broj koji oznacava duljinu bloka

	AREA memfill_v1, CODE, READONLY
	
	ENTRY
	
ADDR EQU 0x8100			; adresa na kojoj se nalaze podatci
	
	MOV R4, #ADDR   	; postavlja registar R4 na adresu podataka
	LDMIA R4!, {R5,R6,R7}	; ucitavanje broja, pocetka i duljine koristenjem
				; Load Multiple naredbe
	CMP R7, #0		; je li duljina bloka = 0
	BEQ KRAJ		; ako je, nema se sto raditi
	
PETLJA	
	STR R5, [R6], #4	; spremi broj i uvecaj adresu
	SUBS R7, R7, #1		; smanji brojac
	BHI PETLJA		; ponavljaj ako je brojac > 0
KRAJ
	MOV R0, #0x18		; angel_SWIreason_ReportException
	LDR R1, =0x20026 	; ADP_Stopped_ApplicationExit
	SWI 0x123456      	; ARM semihosting SWI
		
	END

