; Program za kopiranje bloka memorije, verzija 1
; Parametri: 	0x8100 - tu se nalazi adresa pocetka bloka
;		0x8104 - tu se nalazi duljina bloka
;		0x8108 - tu se nalazi adresa odredista

	AREA memcpy_v1, CODE, READWRITE

ADDR EQU 0x8100				; adresa parametara

	ENTRY

	MOV R8, #ADDR   	
	LDR R4, [R8], #4		; R4 = adresa pocetka bloka
	LDR R5, [R8], #4		; R5 = duljina bloka
	LDR R6, [R8]			; R6 = adresa odredista
	
	CMP R5, #0				; ako duljina = 0 zavrsi
	BEQ KRAJ
	
PETLJA
	LDR R8, [R4], #4
	STR R8, [R6], #4
	SUBS R5, R5, #1
	BNE PETLJA
KRAJ
	MOV R0, #0x18			; angel_SWIreason_ReportException
	LDR R1, =0x20026 	; ADP_Stopped_ApplicationExit
	SWI 0x123456      	; ARM semihosting SWI
		
	END

