; Program za pretvorbu ASCII-znakova u cijeli broj ,ver. 1

	AREA atoi_v1, CODE, READONLY
	
	ENTRY
	
ADDR EQU 0x8100			; adresa na kojoj se nalaze podatci
	
	MOV R4, #ADDR   	; postavlja registar R4 na pocetak podataka
	MOV R7, #8		; brojac ASCII-znakova = 8 
	MOV R6, #0		; resetiranje rezultata

PETLJA
	LDRB R0, [R4], #1	; ucitavanje ASCII-znaka

	SUB R0, R0, #0x30	;pretvorba ASCII-znamenke u binarni
 									;broj:prethodni rezultat se mnozi s 10
	ADD R6, R6, R6, LSL #2	; mnozenje s 5
	ADD R6, R0, R6, LSL #1 	; mnozenje s 2 i zbrajanje
									; tako da je: R6 = (5*R6)*2 + R0
	SUBS R7, R7, #1		; brojac prolaza petlje
	BHI PETLJA		
KRAJ
	STR R6, [R4]			; spemanje rezultata
	MOV R0, #0x18			; angel_SWIreason_ReportException
	LDR R1, =0x20026 	; ADP_Stopped_ApplicationExit
	SWI 0x123456      	; ARM semihosting SWI
		
	END

